﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Garage
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        public void BuyNewCar(object sender, EventArgs e)
        {
            CarDialog diag = new CarDialog();

            if (diag.ShowDialog() == DialogResult.OK)
            {
                carListBox.Items.Add(diag.Car);
            }
        }

        public void SellCar(object sender, EventArgs e)
        {
            carListBox.Items.RemoveAt(carListBox.SelectedIndex);
        }

        public void ModifyCar(object sender, EventArgs e)
        {
            CarDialog diag = new CarDialog();
            diag.Car = (carListBox.SelectedItem as Car);

            if (diag.ShowDialog() == DialogResult.OK)
            {
                int index = carListBox.SelectedIndex;
                carListBox.Items.RemoveAt(index);

                carListBox.Items.Insert(index, diag.Car);
            }
        }

        private void newGarageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            carListBox.Items.Clear();
        }

        private void quitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void carListBox_SelectedValueChanged(object sender, EventArgs e)
        {
            if (carListBox.SelectedItem == null)
            {
                panel.Visible = false;
                modifyToolStripMenuItem.Enabled = false;
                modifyCarButton.Enabled = false;
                sellToolStripMenuItem.Enabled = false;
                sellCarButton.Enabled = false;
            }
            else
            {
                panel.Visible = true;
                modifyToolStripMenuItem.Enabled = true;
                modifyCarButton.Enabled = true;
                sellToolStripMenuItem.Enabled = true;
                sellCarButton.Enabled = true;

                Car selectedCar = (carListBox.SelectedItem as Car);

                nameLabel.Text = String.Format("\"{0}\"", selectedCar.Name);

                manufacturerLabel.Text = selectedCar.Manufacturer;
                priceLabel.Text = String.Format("{0:0.00} €", selectedCar.Price);

                colourButton.BackColor = selectedCar.Colour;
            }
        }
    }
}
